var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
  var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
  if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
  else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
  return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { MapToComponentField, VegaSlimmer } from 'vega-slimmer/core';
/**
 * Manager the check status in vegaSelectionChip.
 */
export class VegaSelectionChipCheckedController extends VegaSlimmer {
  /**
   * Set checked value.
   *
   * @param {boolean} checked - checked
   */
  setChecked(checked) {
    this.checked = checked;
  }
  /**
   * Listen selection chip click to set checked value.
   *
   * @param {boolean} checked - checked.
   */
  onCheck(checked) {
    const value = checked ? this.value : '';
    this.setChecked(checked);
    this.changeEventEmitter.emit(value);
  }
}
__decorate([
  MapToComponentField()
], VegaSelectionChipCheckedController.prototype, "host", void 0);
__decorate([
  MapToComponentField({ writable: true })
], VegaSelectionChipCheckedController.prototype, "checked", void 0);
__decorate([
  MapToComponentField()
], VegaSelectionChipCheckedController.prototype, "changeEventEmitter", void 0);
__decorate([
  MapToComponentField()
], VegaSelectionChipCheckedController.prototype, "value", void 0);
